@echo off

:: ----------------------------------------------------------------------
:: Fr die Bildschirmausgaben mssen fr die deutschen Umlaute folgende
:: Zeichen verwendet werden:
:: 						
:: 						
:: ----------------------------------------------------------------------



echo  ____________________________________________________________________________
echo                                                      http://www.ProCompSys.de
echo.
echo  	version 1.0  2004-12-14 by Uwe Weitz @ ProCompSys
echo. 
echo    Wochentag zu heutigem Datum ermitteln
echo    fr Windows 2000 ^& Windows XP
echo.
echo  ____________________________________________________________________________

echo.
pause

cls
echo.

for /f "tokens=1,2,3,4 delims=. " %%i in ('echo %date%') do (
set T=%%i
set M=%%j
set /a H=%%k/100
set /a J=%%k%%100
)

:: Der gerade durchgefhrte Befehl zum setzen der Variable J fr das Jahr (ohne die beiden fhrenden Stellen
:: fr das Jahrhundert) wird MODULO errechnet, indem er das vierstellige Jahr modulo 100 teilt. Dann bleibt 
:: fr das Jahr 2003 beispielsweise sofort 3 brig und nicht 03.
:: Bei der Tages- und Monats-Angabe mu gleich noch eine evtl. fhrende NUll (fr Monate kleiner 10) 
:: herausgefiltert werden.


echo.
echo DATE's Datum:
echo -----------------
echo %date%
echo.


echo.
echo Die Variablen:
echo -----------------
echo T  M  H  J
echo %T% %M% %H% %J%
echo.
echo.


:: --------------------------------------------------------------------------------------------------------
:: Im folgenden Befehl wird - fr den Fall, da Tag oder Monat kleiner 10 ist - nur das letzte Zeichen von 
:: T bzw. M verwendet, 
:: da bei Zahlen ab 8 mit einer fhrenden Null folgender Fehler ausgegeben wird:
:: * Ungltige Zahl. Nummerische Konstanten sind entweder dezimale (17), hexadezimale (0x11) oder 
:: oktale (021) Zahlen. *
:: Zahlen ab 8, denen eine Null vorangeht, werden als oktale Zahlen interpretiert.

if "%M%" lss "10" (
echo Krze Monat %M% auf %M:~-1%...
set /a M=%M:~-1%
echo.
echo.
)

if "%T%" lss "10" (
echo Krze Tag %T% auf %T:~-1%...
set /a T=%T:~-1%
echo.
echo.
)

:: Innerhalb der gerade verwendeten  IF-Klammern kann ich das neu berechnete M noch nicht mit %M% abfragen,
:: - z.B. mit der Ausgabe "echo M ist jetzt %M%." -  da der neue Wert erst an das System zurckgemeldet wird, 
:: wenn die IF-Klammer wieder geschlossen wurde.
:: ------------------------------------------------------------------------------------------------------------


:: -------------------------------------------------------
if "%J%" EQU "0" (
   set J=00
)
:: -------------------------------------------------------



:: Eigentlich wrde ich jetzt mit IF "%M%" GEQ "3" fr die Zellersche Formel abfragen,
:: ob der Monat grer/gleich 3 ist, aber wegen der Geschichte mit den oktalen Zahlen ab 08 aufwrts
:: fhrt das stndig zu Mergel. Ich mu von 1 bis 9 mit einstelligen Monaten arbeiten, was allerdings
:: dazu fhrt, da 9 grer ist als 10. Also frag ich alle 12 Monate in einzelnen IF-Abfragen ab.
:: ------------------------------------------------------------------------------------------------------------

if "%M%"=="3" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="4" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="5" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="6" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="7" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="8" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="9" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="10" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="11" (
   set /a M=%M%-2
   goto MGROSS
)

if "%M%"=="12" (
   set /a M=%M%-2
   goto MGROSS
)


:: Fr die Monate 1-2 wird dann noch MKLEIN aufgerufen
:: ----------------------------------------------------
CALL :MKLEIN



:MGROSS
set /a W=(%T%+(26*%M%-2)/10+%J%+(%J%/4)+(%H%/4)-(2*%H%))%%7
echo Die Zellersche Formel gibt %W% aus.

if "%W%"=="1" (
 echo Es ist Montag.
)
if "%W%"=="2" (
 echo Es ist Dienstag. 
)
if "%W%"=="3" (
 echo Es ist Mittwoch. 
)
if "%W%"=="4" (
 echo Es ist Donnerstag. 
)
if "%W%"=="5" (
 echo Es ist Freitag. 
)
if "%W%"=="6" (
 echo Es ist Samstag. 
)
:: ------------------------
if "%W%"=="0" (
 echo Es ist Sonntag.
)
:: ------------------------
if "%W%"=="-1" (
 echo Es ist Samstag.
)
if "%W%"=="-2" (
 echo Es ist Freitag.
)
if "%W%"=="-3" (
 echo Es ist Donnerstag.
)
if "%W%"=="-4" (
 echo Es ist Mittwoch.
)
if "%W%"=="-5" (
 echo Es ist Dienstag.
)
if "%W%"=="-6" (
 echo Es ist Montag.
)
	

goto ENDE



:: ===================================================================

:MKLEIN
echo M ist %M%.
echo starte MKLEIN...
set /a M=%M%+10
if "%J%"=="00" (
   set J=99
   set /a H=%H%-1
) ELSE (
   set /a J=%J%-1
)
goto :EOF

:: ===================================================================


:ENDE
echo.
echo.
pause